<?php 
/**
* 实现从gb到big5的编码
*
* @version 1.0.0
* @package Charset
*/

class __gb_big5 extends CharsetTool 
{
	/**
	* 构造函数
	*
	* @access public
	*/
	function __construct()
	{
		parent::__construct();	
	}	
	
	/**
	* 转换编码
	*
	* @param string $string 要转换的字符串
	* @return string 转换的结果
	* @access public
	*/
	function convert($string)
	{
		/*
		if (!Pfc::has("gb_big5_table"))
		{
			$fp = fopen($this->dir . "/Charset/tables/gb-big5.table", "r");
			Pfc::set("gb_big5_table", $fp);
		}
		else 
		{
			$fp = Pfc::get("gb_big5_table");	
		}
		*/
        $fp = fopen($this->dir . "/Charset/tables/gb-big5.table", "r");
       
   		$chars = String::getChars($string);

   		if (!empty($chars))
   		{
   			foreach ($chars as $index=>$char)	
   			{
   				if (strlen($char) > 1)
   				{
   					$o1 = ord($char[0]);
   					$o2 = ord($char[1]);
   					if ($o1 == 161 && $o2 == 64)
   					{
   						$chars[$index] = "  ";	
   					}	   				
   					else 
	   				{
	   					fseek($fp, ($o1 - 160) * 510 + 2 * $o2 -2);
	   					$bChar = fread($fp, 2);
	   					if ($bChar != "") $chars[$index] = $bChar; 	
	   				}		
   				}	
   			}			
   			return implode("", $chars);
   		}
   		return null;
	}
}

?>