<?php
/**
* <b>ת</b>
*
* Ŀǰʵ¡ַת
* - gb <-> big5  
* - gb,big5<->utf-8  
* - gb,big5->unicode, 
* - gb->pinyin
*
* @version 1.0.0
* @author iwind
* @package Charset
*/
class CharsetTool 
{
	/**
	* ǰ·
	*
	* @var string
	* @access private
	*/
	//public $dir;
	
	/**
	* 캯
	* 
	* @access public
	

	function __construct()
	{
		$this->dir = dirname(__FILE__);
	}
    */
	function CharsetTool()
	{
		$this->dir = dirname(__FILE__);
	}


	/**
	* Purpose
	*
	* ת. ֵ֧ı gb<->big5 gb<->utf8 gb->unicode big5<->utf8, big5->unicode,gb->pinyin
	*
	*
	* Examples
	*
	* - $charset->conv("㲻֪Ұ", "gb", "big5");
	* - $charset->conv("ʵ", "gb", "unicode");
	* 
	* @param string $string Ҫתַ
	* @param string $sCharset Դַ
	* @param string $dCharset Ŀַ
	* @return mixed תĽ,תΪƴ,Ϊַ
	* @access public
	*/
	function conv($string, $sCharset, $dCharset)
	{
		$sCharset = str_replace("-", "", $this->tolower($sCharset));
		$dCharset = str_replace("-", "", $this->tolower($dCharset));
		if ($sCharset == "gb2312") $sCharset = "gb";
		if ($dCharset == "gb2312") $dCharset = "gb";
		$className = "__{$sCharset}_{$dCharset}";
        $class = $this->dir . "/Charset/{$className}.php";
		if (!file_exists($class))
		{
			echo ("Ŀǰвʵִ {$sCharset}  {$dCharset} ת");
			return false;	
		}	
		require_once $class;

		$instance = new $className();
		return $instance->convert($string);
	}
	

	function tolower($string)
    {
        return strtolower($string);
    }



	/**
	* ̬õķ
	*
	* @param string $string Ҫתַ
	* @param string $sCharset Դַ
	* @param string $dCharset Ŀַ
	* @return mixed תĽ,תΪƴ,Ϊַ
	* @access public
	*/
	function convert($string, $sCharset, $dCharset)
	{
		$chr = new CharsetTool();
		return $chr->conv($string, $sCharset, $dCharset);	
	}
	
	/**
	* 16ת2    	
	*
	* @param string $hexdata ʮλ
	* @return string 
	* @access private
	*/
	function hex2bin($hexdata)
    {
    	$len = strlen($hexdata);
    	$bindata = "";
    	for ( $i = 0; $i < $len; $i += 2)
    	{
    		$bindata .= chr(hexdec(substr($hexdata,$i,2)));
    	}
   		return $bindata;
    }
}

?>