<?php
class String
{

	/** 
	* 캯
	* 
	* @access public
	*/
    function __construct()
    {

    }

    /**
    * <b>Ľȡ</b>  
    * - һĵһַ.
    *
    * ʹ÷  
    * - string::substring("this is an example", 5)
    * - string::substring("this is an example", 5, 10);
    *
    * @param string $string ȡַ
    * @param integer $start  ʼȡĵط
    * @return string ȡ
    * @access public
    */
    function substring($string, $start)
    {
    	$args = func_get_args();
    	if (function_exists("iconv_substr"))
    	{
    		$string = (isset($args[2]))?iconv_substr($string, $start, $args[2], "GBK"):iconv_substr($string, $start, strlen($string) + 1, "GBK");
    		return $string; 	
    	}
    	if (function_exists("mb_substr"))
    	{
    		$string = (isset($args[2]))?mb_substr($string, $start, $args[2], "GBK"):mb_substr($string, $start, strlen($string) + 1, "GBK");
    		return $string; 	
    	}
        $m = string::getChars($string);
        if (isset($args[2]))
        {
            return implode("", array_splice($m, $start, $args[2]));
        }
        else
        {
            return implode("", array_splice($m, $start));
        }
    }

    /**
    * һĵ˫ֽĽȡ
    *
    * @param string $string ȡַ
    * @param integer $start ʼȡĵط
    * @return string ȡ
    * @access public
    */
    function substring2($string, $start)
    {
        $array = string::getChars($string);
        $args = func_get_args();
      	if (isset($args[2])) $len = integer::toInt($args[2]); 
        $count = 0;
        $result = "";
        if (!empty($array))
        {
        	foreach ($array as $v)
        	{
        		$count += strlen($v);
        		if ($count >= $start)
        		{
        			if (isset($len))
        			{
        				if ($count <= $len)
        				{
        					$result .= $v;	
        				}
        				else 
        				{
        					break;	
        				}
        			}
        			else 
        			{
        				$result .= $v;	
        			}
        		}	
        	}	
        }
        return $result;
    }
    
    /**
    * һַ߽ȡһȵַ
    *
    * @param string $string Ҫȡַ
    * @param integer $length ȡ
    * @param boolean $multi ǰѰһĵֽ
    * @return string ȡĽ
    * @access public
    */
    function left($string, $length, $multi = false)
    {
    	$length = intval($length);
		return ($multi)?string::substring2($string, 0, $length):string::substring($string, 0, $length);    	
    }
    
    /**
    * һַұ߽ȡһȵַ
    *
    * @param string $string Ҫȡַ
    * @param integer $length ȡ
    * @param boolean $multi ǰѰһĵֽ
    * @return string ȡĽ
    * @access public
    */
    function right($string, $length, $multi = false)
    {
    	$length = intval($length);
    	$string = strrev($string);
		return strrev(($multi)?string::substring2($string, 0, $length):string::substring($string, 0, $length));    	
    }
    
    /**
    * תַ
    *
    * @param object $object һĶ
    * @return string ת
    * @access public
    */
    function toString($object)
    {
        return strval($object);
    }

    /**
    * һַתһ,ַ.
    *
    * @param object $object ҪתĶ
    * @return array 
    * @access public
    */
    function getChars($object)
    {
        $string = string::toString($object);
        preg_match_all("/[\x81-\xfe]?./", $string, $m);
        return $m[0];
    }

    /**
    * õһַĳ,ĵֽ
    *
    * @param string $string Ҫַ
    * @return integer 
    * @access public
    */
    function length($string)
    {
        return count(string::getChars($string));
    }
    
    /**
    * һַСдĸתɴд
    *
    * @param string $string ҪתĶ
    * @return string ת
    * @access public
    */
    function toupper($string)
    {
        return strtoupper($string);
    }

    /**
    * һַддĸתСд
    *
    * @param string $string ҪתĶ
    * @return string ת
    * @access public
    */
    function tolower($string)
    {
        return strtolower($string);
    }

   	/**
    * ֤һַǷֻ,ȫ,,Ӣ,»
    *
    * @param string string Ҫַ
    * @return boolean
    * @access public
    */
    function checkChs($string)
    {
        $chars = string::getChars($string);
        foreach ($chars as $char)
        {
            if (strlen($char) == 1 && !preg_match("/[a-z0-9_]/i", $char))
            {
                return false;
            }
        }
        return true;
    }

    /**
    * һַкһַĸ
    *
    * @param string $string ַ
    * @param string $sub ַ
    * @return integer 
    * @access public
    */
    function getNeedleCount($string, $sub)
    {
        return substr_count($string, $sub);
    }
    
    /**
    * ַ֮ƶȣԵһַΪ׼
    * 
    * @param string $string1 һַ
    * @param string $string2 ڶַ
    * @return float һλС
    * @access public
    */
    function similar($string1, $string2)
    {
    	similar_text($string1, $string2, $similarity);
    	return round(0.01 * $similarity, 2);    		
    }
}



?>