<?php 
/**
* 实现从big5到gb的编码
*
* @version 1.0.0
* @package charset
*/

class __big5_gb extends CharsetTool 
{
	/**
	* 构造函数
	* 
	* @access public
	*/
	function __construct()
	{
		parent::__construct();
	}
	
	/**
	* 转换编码
	* @param string $string 要转换的字符串
	* @return string 转换的结果
	* @access protected
	*/
	function convert($string)
	{
		/*
		if (!Pfc::has("big5_gb_table"))
		{
			$fp = fopen($this->dir . "/Charset/tables/big5-gb.table", "r");
			Pfc::set("big5_gb_table", $fp);
		}
		else 
		{
			$fp = Pfc::get("big5_gb_table");	
		}
		*/
   	    
		$fp = fopen($this->dir . "/Charset/tables/big5-gb.table", "r");
   		$chars = String::getChars($string);
   		if (!empty($chars))
   		{
   			foreach ($chars as $index=>$char)	
   			{
   				if (strlen($char) > 1)
   				{
   					$o1 = ord($char[0]);
   					$o2 = ord($char[1]);
   					if ($o1 == 161 && $o2 == 64)
   					{
   						$chars[$index] = "  ";	
   					}	   				
   					else 
	   				{
	   					fseek($fp, ($o1 - 160) * 510 + 2 * $o2 -2);
	   					$bChar = fread($fp, 2);
	   					if ($bChar != "") $chars[$index] = $bChar; 	
	   				}		
   				}	
   			}
   			return implode("", $chars);
   		}
   		return null;
	}
}

?>