<?php 
/**
* 实现从gb到utf8的编码
*
* @version 1.0.0
* @package Charset
*/

class __gb_utf8 extends CharsetTool  
{
	/**
	* 构造函数
	*
	* @access public
	*/
	function __construct()
	{
		parent::__construct();	
	}	
	
	/**
	* 转换编码
	*
	* @param string $string 要转换的字符串
	* @return string 转换的结果
	* @access public
	*/
	function convert($string)
	{
		if (function_exists("iconv"))
		{
			$string = iconv("gb2312", "utf-8", $string);	
			return $string;
		}
		if (function_exists("mb_convert_encoding"))
		{
			$string = mb_convert_encoding($string, "utf-8", "gb2312");
			return $string;	
		}
		$string = parent::translate(parent::convert($string, "gb", "unicode"), "unicode", "utf-8");
		return $string;
	}
}


?>