<?php
/******************************************
 *
 * 文件名: Html_Smarty.php
 * 作  用: 扩展Samrty类,使它能够生成静态页
 *
 * 作  者:  大白菜芯
 * Email:  php_netproject@yahoo.com.cn
 *
 *******************************************/
  require_once 'Smarty.class.php';
  
  $Templates_root = $doc_root."/shopadmin";  //定义摸版根目录
  define("Templates",$Templates_root);

  $tpl = new Smarty();                                           //建立smarty实例对象$smarty
  $tpl->debugging = flase;
  $tpl->template_dir   = Templates."/templates";                 //设置模板目录
  $tpl->compile_dir    = Templates."/templates_c";               //设置编译目录
  $tpl->cache_dir      = $doc_root."/cache";                     //设置缓存目录
  //$tpl->cache_lifetime = 60 * 60 * 24;                         //设置缓存时间
  $tpl->cache_lifetime = 0;                                      //设置缓存时间
  $tpl->caching        = false;                                  //这里是调试时设为false,发布时请使用true
  $tpl->left_delimiter = '<{';
  $tpl->right_delimiter= '}>';

  class Html_Smarty extends Smarty 
  {
    function MakeHtmlFile($fileName,  $Content="")
	{
	  if(!$fp = fopen($fileName, "w+")) 
      {
	    echo "<b>problem open $fileName!</b>";

		return false;
	  }

	  if(!fwrite($fp, $Content))
	  {
	     echo "<b>problem write $fileName!</b>";
         fclose($fp);
		 return false;
	  }
      
	  fclose($fp);
	  return true;
	}
  }
?>